#include <avr/io.h>
#define F_CPU 8000000UL
#include <util/delay.h>

#define C12	0x80
#define C22	0x40
#define C32 0x20
#define C42 0x10

#define C11 0x08
#define C21 0x04
#define C31 0x02
#define C41 0x01

#define C43	0x80
#define C33	0x40
#define C23 0x20
#define C13 0x10

#define C44 0x08
#define C34 0x04
#define C24 0x02
#define C14 0x01

#define L1 0x40
#define L2 0x20
#define L3 0x10
#define L4 0x08

#define ALL 0x78
void ploaie_col(){
	int i,j;
	for (j=0;j<5;j++){
		for(i=0;i<4;i++){
			if (i%4==0) PORTD=L1;
			if (i%4==1) PORTD=L2;
			if (i%4==2) PORTD=L3;
			if (i%4==3) PORTD=L4;
			PORTA = 0;
			PORTC = C11 | C21 | C31 | C41;
			_delay_ms(1500);
		}
		
		for(i=0;i<4;i++){
			if (i%4==0) PORTD=L1;
			if (i%4==1) PORTD=L2;
			if (i%4==2) PORTD=L3;
			if (i%4==3) PORTD=L4;
			PORTA = 0;
			PORTC = C12 | C22 | C32 | C42;
			_delay_ms(1500);
		}
		
		for(i=0;i<4;i++){
			if (i%4==0) PORTD=L1;
			if (i%4==1) PORTD=L2;
			if (i%4==2) PORTD=L3;
			if (i%4==3) PORTD=L4;
			PORTC = 0;
			PORTA = C13 | C23 | C33 | C43;
			_delay_ms(1500);
		}
		for(i=0;i<4;i++){
			if (i%4==0) PORTD=L1;
			if (i%4==1) PORTD=L2;
			if (i%4==2) PORTD=L3;
			if (i%4==3) PORTD=L4;
			PORTC = 0;
			PORTA = C14 | C24 | C34 | C44;
			_delay_ms(1500);
		}
	}
}
void plin(){

	int i;
	PORTD = L1 | L2| L3| L4;
	for (i=0;i<6;i++){
		if (i%2 ==0){
			PORTA =0; PORTC =0;
			PORTC = C11 | C21 | C31 | C41;
			_delay_ms(1500);
			PORTC = PORTC | C12 | C22 | C32 | C42;
			_delay_ms(1500);
			PORTA = C13 | C23 | C33 | C43;
			_delay_ms(1500);
			PORTA = PORTA | C14 | C24 | C34 | C44;
			_delay_ms(1500);
		}else {
			PORTC=0; PORTA=0;
			PORTA = C14 | C24 | C34 | C44;
			_delay_ms(1500);
			PORTA = PORTA | C13 | C23 | C33 | C43;
			_delay_ms(1500);
			PORTC = C12 | C22 | C32 | C42;
			_delay_ms(1500);
			PORTC = PORTC | C11 | C21 | C31 | C41;
			_delay_ms(1500);
			
		}
	}
}
void lacrimi(){
	int i,j;
	for (j=0;j<16;j++){
		for (i=0;i<4;i++){
			if (i%4==0) PORTD=L1;
			if (i%4==1) PORTD=L2;
			if (i%4==2) PORTD=L3;
			if (i%4==3) PORTD=L4;
			if (j==0) {PORTC = C11; PORTA =0;}
			if (j==1) {PORTC = C12; PORTA =0;}
			if (j==2) {PORTA = C13; PORTC =0;}
			if (j==3) {PORTA = C14; PORTC =0;}
			if (j==4) {PORTC = C21; PORTA =0;}
			if (j==5) {PORTC = C22; PORTA =0;}
			if (j==6) {PORTA = C23; PORTC =0;}
			if (j==7) {PORTA = C24; PORTC =0;}
			if (j==8) {PORTC = C31; PORTA =0;}
			if (j==9) {PORTC = C32; PORTA =0;}
			if (j==10) {PORTA = C33; PORTC =0;}
			if (j==11) {PORTA = C34; PORTC =0;}
			if (j==12) {PORTC = C41; PORTA =0;}
			if (j==13) {PORTC = C42; PORTA =0;}
			if (j==14) {PORTA = C43; PORTC =0;}
			if (j==15) {PORTA = C44; PORTC =0;}
			_delay_ms(1500);
		}
	}
		
}
void ploaie_int(){
	int i;
	for (i=0;i<4;i++){
		if (i%4==0) PORTD=L1;
		if (i%4==1) PORTD=L2;
		if (i%4==2) PORTD=L3;
		if (i%4==3) PORTD=L4;
		PORTA = C23 | C33;
		PORTC = C22 | C32;
		_delay_ms(2400);
	}
	for (i=0;i<4;i++){
		if (i%4==0) PORTD=L1;
		if (i%4==1) PORTD=L2;
		if (i%4==2) PORTD=L3;
		if (i%4==3) PORTD=L4;
		PORTA = C43 | C13 | C44 | C34 | C24 | C14;
		PORTC = C11 | C21 | C31 | C41 | C12 | C42;
		_delay_ms(2400);
	}
}
void un_led(int i){
				if (i%4==0) PORTD=L1;
				if (i%4==1) PORTD=L2;
				if (i%4==2) PORTD=L3;
				if (i%4==3) PORTD=L4;
				PORTA=0;
				PORTC=C11;
				_delay_ms(1200);
				
				PORTA=0;
				PORTC=C21;
				_delay_ms(1200);
				
				PORTA=0;
				PORTC=C31;
				_delay_ms(1200);
				
				PORTA=0;
				PORTC=C41;
				_delay_ms(1200);
				
				PORTA=0;
				PORTC=C42;
				_delay_ms(1200);
				
				PORTA=0;
				PORTC=C32;
				_delay_ms(1200);
				
				PORTA=0;
				PORTC=C22;
				_delay_ms(1200);
				
				PORTA=0;
				PORTC=C12;
				_delay_ms(1200);
				
				PORTC=0;
				PORTA=C13;
				_delay_ms(1200);
				
				PORTC=0;
				PORTA=C23;
				_delay_ms(1200);
				
				PORTC=0;
				PORTA=C33;
				_delay_ms(1200);
				
				PORTC=0;
				PORTA=C43;
				_delay_ms(1200);
				
				PORTC=0;
				PORTA=C44;
				_delay_ms(1200);
				
				PORTC=0;
				PORTA=C34;
				_delay_ms(1200);
				
				PORTC=0;
				PORTA=C24;
				_delay_ms(1200);
				
				PORTC=0;
				PORTA=C14;
				_delay_ms(1200);
}
void ploaie(){
			PORTD=L1;
			PORTA=0xFF;
			PORTC=0xFF;
			_delay_ms(2500);
			
			PORTD=L2;
			PORTA=0xFF;
			PORTC=0xFF;
			_delay_ms(2500);
			
			PORTD=L3;
			PORTA=0xFF;
			PORTC=0xFF;
			_delay_ms(2500);
			
			PORTD=L4;
			PORTA=0xFF;
			PORTC=0xFF;
			_delay_ms(2500);
}
void stanga_dreapta(){
			PORTD = ALL;
			PORTC = C11 | C21 | C31 | C41;
			PORTA = 0x00;
			_delay_ms(2500);
			
			PORTD = ALL;
			PORTC = C12 | C22 | C32 | C42;
			PORTA = 0x00;
			_delay_ms(2500);
			
			PORTD=ALL;
			PORTA= C13 | C23 | C33 | C43;
			PORTC=0x00;
			_delay_ms(2500);
			
			PORTD=ALL;
			PORTA=C14 | C24 | C34 | C44;
			PORTC=0x00;
			_delay_ms(2500);
			
			PORTD=ALL;
			PORTA=0b11110000;
			PORTC=0b00000000;
			_delay_ms(2500);
			
			PORTD=ALL;
			PORTC=0b11000011;
			PORTA=0b00000000;
			_delay_ms(2500);
}
void cerc(){
			PORTD=ALL;
			PORTA=0x48;
			PORTC=0x21;
			_delay_ms(800);
		
			
			PORTA=0xC0;
			PORTC=0x03;
			_delay_ms(800);
		
			PORTC=0xC0;
			PORTA=0x30;
			_delay_ms(800);
	
			PORTC=0x84;
			PORTA=0x81;
			_delay_ms(800);
		
			PORTC=0x88;
			PORTA=0x42;
			_delay_ms(800);

			PORTC=0x11;
			PORTA=0x44;
			_delay_ms(800);
}
void spirala(){
			PORTD = ALL;
			PORTA = 0;
			PORTC = C11;
			_delay_ms(800);
			PORTA = 0;
			PORTC = C21;
			_delay_ms(800);
			PORTA = 0;
			PORTC = C31;
			_delay_ms(800);
			PORTA = 0;
			PORTC = C41;
			_delay_ms(800);
			
			PORTA = 0;
			PORTC = C42;
			_delay_ms(800);
			PORTC = 0;
			PORTA = C43;
			_delay_ms(800);
			PORTC = 0;
			PORTA = C44;
			_delay_ms(800);
			
			PORTC = 0;
			PORTA = C34;
			_delay_ms(800);
			PORTC = 0;
			PORTA = C24;
			_delay_ms(800);
			PORTC = 0;
			PORTA = C14;
			_delay_ms(800);
			
			PORTC = 0;
			PORTA = C13;
			_delay_ms(800);
			PORTA = 0;
			PORTC = C12;
			_delay_ms(800);
			
			PORTA = 0;
			PORTC = C22;
			_delay_ms(800);
			PORTA = 0;
			PORTC = C32;
			_delay_ms(800);
			PORTC = 0;
			PORTA = C33;
			_delay_ms(800);
			PORTC = 0;
			PORTA = C23;
			_delay_ms(800);
}
void intern_extern (){
		PORTD = ALL;
		PORTA = C43 | C13 | C44 | C34 | C24 | C14;
		PORTC = C11 | C21 | C31 | C41 | C12 | C42;
		_delay_ms(2*3600);
		
		PORTA = PORTC = 0;
		PORTA = C23 | C33;
		PORTC = C22 | C32;
		_delay_ms(2*3600);
}
int main(){
	// output pe pini
	DDRD = 0xFF;
	DDRC = 0xFF;
	DDRA = 0xFF;
	int i;
	while(1){
	
		for (i=0;i<9;i++)
		{	
			un_led(i);
			
		}		
		
		for (i=0;i<5;i++)
		{
			ploaie();		
		}	
		
		for (i=0;i<5;i++)
		{
			stanga_dreapta();	
		}	
		
		for (i=0;i<15;i++)
		{
			cerc();
		}	
		
		for ( i = 0 ; i < 5 ; i++){
			spirala();
		}
		
		for ( i= 0; i<5 ; i++){
			intern_extern();
		}
		
		for ( i= 0 ;i < 5 ;i++){
			ploaie_int();
		}
		lacrimi();
		plin();
		ploaie_col();
	}
	return 0;
}